Features/PolicyKitOne

From FedoraProject

< Features(Difference between revisions)
Jump to: navigation, search
(mark gnome-lirc-properties as done)
(Current status)
 
Line 11: Line 11:
 
== Current status ==
 
== Current status ==
 
* Targeted release: [[Releases/12 | Fedora 12 ]]  
 
* Targeted release: [[Releases/12 | Fedora 12 ]]  
* Last updated: 2009-08-26
+
* Last updated: 2009-09-24
* Percentage of completion: 99%
+
* Percentage of completion: 100%
  
PolicyKit 0.94 is the current release of the new PolicyKit. See the [http://lists.freedesktop.org/archives/polkit-devel/2009-August/000200.html announcement]
+
PolicyKit 0.95 is the current release of the new PolicyKit.
  
 
The polkit, polkit-gnome and polkit-desktop-policy packages are in rawhide now.
 
The polkit, polkit-gnome and polkit-desktop-policy packages are in rawhide now.
 
+
The PolicyKit 0.9 packages have been obsoleted.
See below for that status of porting everything to the new api.
+
 
+
David has written a detailed outline of the remaining plans [http://lists.freedesktop.org/archives/polkit-devel/2009-June/000135.html here].
+
 
+
Next steps:
+
* finish porting (see table below)
+
* obsolete PolicyKit 0.9
+
  
 
== Detailed Description ==
 
== Detailed Description ==

Latest revision as of 12:40, 24 September 2009


Contents

[edit] PolicyKit 1.0

[edit] Summary

PolicyKit provides a flexible framework for granting users access to privileged operations. It is meant to replace the old userhelper approach, and overcome some of its shortcomings. PolicyKit 1.0 addresses architectural shortcomings of the initial PolicyKit design.

[edit] Owner

[edit] Current status

  • Targeted release: Fedora 12
  • Last updated: 2009-09-24
  • Percentage of completion: 100%

PolicyKit 0.95 is the current release of the new PolicyKit.

The polkit, polkit-gnome and polkit-desktop-policy packages are in rawhide now. The PolicyKit 0.9 packages have been obsoleted.

[edit] Detailed Description

The initial Releases/FeaturePolicyKit as introduced in Fedora 8 has some shortcomings. E.g. it is based on a library with suid helpers. The shortcoming that motivated the rewrite is that it is not possible to integrate it with directory services such as FreeIPA. The new PolicyKit is implemented as a system bus service and has pluggable backends that make it easy to integrate with directory services. It is one of the goals of the Features/SSSD feature to write such a backend. PolicyKit 1.0 itself will ship with a backend that uses the local filesystem to store action definitions and authorizations, similar to the current PolicyKit.

More details can be found in Davids announcement of the PolicyKit 0.90 release and in his plans for the local authority.

The current plan is to land the new PolicyKit early in F12 (as soon as it opens up, basically), and have most of the patches ready to port applications. The old PolicyKit 0.9 packages can remain for a while to ease the transition period and will be removed a few months into F12, when all users have been ported.

[edit] Benefit to Fedora

Making it possible to manage policies in a central directory service makes Fedora more suitable for larger, centrally managed installations.

As a secondary benefit, the new PolicyKit api is much simpler to work with than the PolicyKit 0.9 api.

[edit] Scope

  • Package EggDbus, which is a dependency of the new PolicyKit
  • Package the new PolicyKit, making it parallel-installable with the current PolicyKit
  • Port supporting libraries such as PolicyKit-gnome and PolicyKit-kde to the new PolicyKit or obsolete them
  • Complete PolicyKit 1.0, including documentation and porting guide
  • Port PolicyKit-using applications to the new PolicyKit:
Package Status Bug
NetworkManager done 499965
DeviceKit-disks done
gnome-disk-utility done
DeviceKit-power done 498695
gnome-power-manager done 498560
PackageKit done
gnome-packagekit done
PackageKit-qt done 499968
hal done 499969
libvirt done 499970
gnome-system-monitor done 495730
ConsoleKit done 495617
gdm done 498361
pulseaudio done 497621
control-center done 498365
fprintd done 498368
gnome-panel done 498366
gnome-applets done 499972
GConf2 done 498370
gconf-editor done 505645
gnome-session needs new ConsoleKit api, see below 497619
system-config-services 500007
cups-pk-helper done 499971
libconcord 516067
gnome-lirc-properties done 516069 GNOME 594899
argyllcms 516072

[edit] How To Test

  1. Make sure you have polkit and polkit-gnome 0.91 or newer installed.
  2. Make sure /usr/libexec/polkit-gnome-authentication-agent-1 is automatically started when you log in
  3. Choose a operation that require authorization and are using PolicyKit, e.g. setting the system timezone in the clock applet
  4. Try the operation and verify that you get a PolicyKit password dialog according to the policy
  5. Test that entering the wrong password does not let you execute the operation
  6. Test that entering the correct password lets you execute the operation
  7. Verify that the authorization is remembered according to the policy for this operation, and that a statusicon informs you about currently remembered authorizations
  8. Verify that you can drop the authorizations from the status icon
  9. Try changing the policy for the operation by editing the corresponding policy file
  10. Check that the policy changes are effective immediately
  11. Verify that logging out and back in removes all remembered authorizations

Repeat these tests with other operations that require authorization, such as storing system connections in nm-applet or changing the default desktop background.

[edit] User Experience

The authentication dialogs that are shown by PolicyKit will change in some aspects. The 'retain authorization' checkboxes will likely go away and be replaced with a status icon in the style of consolehelper-gtk, that lets you inspect and drop your retained authorizations.

The policy editor under System → Preferences → Authorizations is going to go away. It is a really problematic interface, and not really needed for normal users. Instead we want to add a simple group-based UI to a future user account dialog, that will let you declare that a user is an 'Administrator' or a 'Guest'. PolicyKit 1.0 includes all the infrastructure for this.

[edit] Dependencies

[edit] Contingency Plan

If PolicyKit 1.0 fails catastrophically, go back to PolicyKit 0.9. All of the patches listed above will have to be backed out.

If not all ports listed above can be completed in time, keep PolicyKit 0.9 around, and don't add the Obsoletes: line.

[edit] Documentation

PolicyKit documentation, including API documentation and manual pages, can be found here. In particular, see the architectural overview.

[edit] Release Notes

Fedora 12 includes PolicyKit 1.0.

In contrast to earlier PolicyKit releases in Fedora 10 and 11, this version of PolicyKit does not include a graphical application to manage individual authorizations. Instead, policies can be defined in simple text files and by associated with Unix groups. The polkit-desktop-policy package contains policy definitions suitable for 'Administrator' and 'Standard User' roles on a standalone desktop installation. See the PolicyKit documentation for more information about policies and how they are defined. This information is also available in the polkit(8) manual page.

PolicyKit 1.0 includes a status icon that informs about elevated privileges and provides an easy way to drop these privileges.

[edit] Comments and Discussion